﻿var mr = {
	r : []
};

function dround(nr) {
	if (nr<1) {
		return round(nr,3);
	}
	if (nr<10) {
		return round(nr,2);
	}
	return round(nr,1);
}

function findMaxPower() {
	//var umin = parseFloat($('#umin').val());
	var umax = parseFloat($('#umax').val());
	//var pmin = parseFloat($('#pmin').val());
	var pmax = parseFloat($('#pmax').val());
	var rmin = parseFloat($('#rmin').val());
	var rmax = parseFloat($('#rmax').val());
	var imax = parseFloat($('#imax').val());
	var tmpU, tmpI, tmpR1, tmpR2;
	$('#res').find('.imax').html(imax);
	$('#res').find('.umax').html(umax);
	$('#res').find('.pmax').html(pmax);
	$('#res').find('.rmin').html(rmin);
	$('#res').find('.rmax').html(rmax);
	// Voltage limit
	tmpU = pmax/imax;
	$('#res1').find('.ures').html(dround(tmpU));
	if (tmpU>umax) {
		$('#res1 .maxu').show();
		tmpU = umax;
	} else {
		$('#res1 .maxu').hide();
	}
	tmpR1 = tmpU/imax;
	$('#res1').find('.rres').html(dround(tmpR1));
	if (tmpR1<rmin) {
		$('#res1 .minr').show();
		$('#res1 .maxr').hide();
		tmpR1 = rmin;
	} else if (tmpR1>rmax) {
		$('#res1 .minr').hide();
		$('#res1 .maxr').show();
		tmpR1 = rmax;
	} else {
		$('#res1 .minr').hide();
		$('#res1 .maxr').hide();
	}
	$('#res3').find('.rmin').html(dround(tmpR1));
	// Current limit
	tmpI = pmax/umax;
	$('#res2').find('.ires').html(dround(tmpI));
	if (tmpI>imax) {
		tmpI = imax;
		$('#res2 .maxi').show();
	} else {
		$('#res2 .maxi').hide();
	}
	tmpR2 = umax/tmpI;
	$('#res2').find('.rres').html(dround(tmpR2));
	if (tmpR2<rmin) {
		$('#res2 .minr').show();
		$('#res2 .maxr').hide();
		tmpR2 = rmin;
	} else if (tmpR2>rmax) {
		$('#res2 .minr').hide();
		$('#res2 .maxr').show();
		tmpR2 = rmax;
	} else {
		$('#res2 .minr').hide();
		$('#res2 .maxr').hide();
	}
	$('#res3').find('.rmax').html(dround(tmpR2));
	
	// middle spot?
	var middle = umax / imax;
	var limitedmiddle;
	//console.log(middle);
	if (middle < rmin) {
		$('#res3 .rmid').html('<s title="Median resistance is below ohm limit." class="text-muted helpcursor">' + dround(middle) + '</s> ' + dround(rmin));
		limitedmiddle = rmin;
	} else if (middle > rmax) {
		$('#res3 .rmid').html('<s title="Median resistance is above ohm limit." class="text-muted helpcursor">' + dround(middle) + '</s> ' + dround(rmax));
		limitedmiddle = rmax;
	} else {
		$('#res3 .rmid').html(dround(middle));
		limitedmiddle = middle;
	}
	
	// en gang
	var sweet1 = (tmpR2 + limitedmiddle)/2;
	$('#res3 .rsweet').html(dround(sweet1));
	var html = '';
	if (tmpR1===tmpR2) {
		html += 'No resistance range? Try decreasing the max power.';
		$('#res3 .panel-footer').show();
	} else {
		$('#res3 .panel-footer').hide();
	}
	$('#res3 .panel-footer .help-block').html(html);
	
	return;
}

function getPresetId(chip) {
	var ii;
	//console.log('finner id for ' + chip);
	for (ii = 0; ii < mr.presets.length; ii++) {
		if (mr.presets[ii].chipnm === chip) {
			//console.log('fant id ' + ii + ' for ' + chip);
			return ii;
		}
	}
	console.warn('Could not find id for ' + chip);
	return;
}

function makePresetDropdown(res) {
	mr.presets = res;
	var ii, xx = [], tmp;
	xx.push('<option value=""></option>');
	for (ii=0; ii < mr.presets.length; ii++) {
		//console.log(mr.presets[ii]);
		if (mr.presets[ii].chip) {
			tmp = getPresetId(mr.presets[ii].chip);
			xx.push('<option value="'+tmp+'" class="notranslate syn">'+mr.presets[ii].nm+' ('+mr.presets[tmp].nm+')</option>');
		} else {
			xx.push('<option value="'+ii+'" class="notranslate">'+mr.presets[ii].nm+'</option>');
		}
	}
	xx.push('<option value="unknown">My APV is not in the list</option>');
	$('#modpreset').html(xx.join(''));
	return;
}

function getPresets() {
	var $pre = $('#presetjson');
	if ($pre.length > 0) {
		makePresetDropdown($.parseJSON($pre.text()));
	} else {
		$.getJSON('modrange-presets.json', function(res) {
			makePresetDropdown(res);
		}).fail(function() {
			$('#modpreset').html('<option value=""></option><option value="">Could not load presets.</option>');
		});
	}
	return;
}

$(document).ready(function() {
	findMaxPower();
	$('input').change(function() {
		findMaxPower();
	});
	$('#modpreset').change(function() {
		var id = $(this).val();
		var valgt;
		if (id === '') { return; }
		if (id === 'unknown') {
			feedbackModal(
				'Suggest APV preset'
				,'<p>If you don\'t find your mod among the presets, you can <strong>manually enter the stats</strong> in the calculator.</p><p>If you also want your VV/VW mod to be listed in the presets some time in the future, you can suggest it here. Please fill out all the specifications.</p><p><strong>Incomplete submissions will be deleted.</strong> Without all the required specs, it is not possible to calculate anything useful.</p>'
				,'Manufacturer (REQUIRED): \nModel name (REQUIRED): \nMax voltage (REQUIRED): \nMax power (REQUIRED): \nMax current (REQUIRED): \nMin/max resistance (optional): \nMin voltage (optional): \nMin power (optional): '
			);
			$('.modal-body textarea').css('height','10em');
			return;
		}
		valgt = mr.presets[id];
		if (valgt.umin === undefined) { valgt.umin = 0; }
		if (valgt.umax === undefined) { valgt.umax = 999; }
		if (valgt.pmin === undefined) { valgt.pmin = 0; }
		if (valgt.pmax === undefined) { valgt.pmax = 999; }
		if (valgt.imax === undefined) { valgt.imax = 999; }
		$('#umin').val(dround(valgt.umin));
		$('#umax').val(dround(valgt.umax));
		$('#pmin').val(dround(valgt.pmin));
		$('#pmax').val(dround(valgt.pmax));
		$('#imax').val(dround(valgt.imax));
		if (valgt.rmin === undefined) {
			valgt.rmin = 0.01;
			$('#rmin').val('');
		} else {
			$('#rmin').val(dround(valgt.rmin));
		}
		if (valgt.rmax === undefined) {
			valgt.rmax = 999;
			$('#rmax').val('');
		} else {
			$('#rmax').val(dround(valgt.rmax));
		}
		findMaxPower();
		gad('modrange', 'preset', $(this).find('option:selected').html().replace(/ /g, '_'));
		
	});
	$('#hidesyns').click(function() {
		if ($(this).is(':checked')) {
			$('#modpreset option.syn').hide();
		} else {
			$('#modpreset option.syn').show();
		}
	});
	getPresets();
});